<template lang="pug">
b-card
	template( #icon )
		label.icon( :for='_uid' )
			i.fa-solid.fa-plus-circle

	input.is-hidden( type="file" @change='handleInput' :id='_uid' multiple )
	b-drop.columns.is-block.is-multiline.is-variable.is-1( v-model='onUpload' )
		.column.is-inline-block.is-2( v-if='list && list.length' v-for='(file, i) in list' :key='i' )
			b-file( :file='file' :is-upload='!!onUpload.length' @remove='onUpload.splice(i, 1)' @select='handleSelect(file)' :selected='isSelected(file)' )
		.column.is-inline-block.is-12( v-else )
			.content.mb-0
				p.is-size-5.has-text-weight-semibold.has-text-centered {{$t("default.no_files")}}

	template( #footer v-if='!onlyOne' )
		template( v-if='onUpload.length' )
			a.card-footer-item.has-text-success( @click='upload' ) {{$t("buttons.upload")}} ({{ onUpload.length }})
			a.card-footer-item.has-text-danger( @click='onUpload = []' ) {{$t("buttons.cancel")}}
		template( v-else )
			template( v-if='selected.length' )
				a.card-footer-item.has-text-info( @click='selected = []' ) {{$t("buttons.remove_selection")}}
				a.card-footer-item.has-text-success( v-if='!onlyEdit' @click='select' ) {{$t("buttons.select")}} ({{ selected.length }})
				a.card-footer-item.has-text-danger( @click='remove' ) {{$t("buttons.delete")}} ({{ selected.length }})
			template( v-else )
				a.card-footer-item.has-text-info( @click='selectAll' ) {{$t("buttons.select_all")}}
loading( :active='pending' )
</template>

<script setup>
import BDrop from "./Drop.vue"
import BFile from "./File.vue"

import { useImagesStore } from "@/stores/images"
import { computed, getCurrentInstance, onMounted, ref, watch } from "vue"

import { useToast } from "vue-toastification"
import { useI18n } from "vue-i18n"

const emit = defineEmits(["select"])
const props = defineProps({
	loading: Boolean,
	onlyOne: Boolean,
	onlyEdit: Boolean
})

const cloud = import.meta.env.VITE_CLOUD

const { t } = useI18n()
const toast = useToast()
const ims = useImagesStore()

const onUpload = ref([])
const selected = ref([])
const pending = ref(props.loading)

const $t = computed(() => t)
const _uid = computed(() => getCurrentInstance().uid)
const list = computed(() => onUpload.value.length ? onUpload.value : ims.images)

watch(() => props.loading, nv => pending.value = nv)

const selectAll = () => {
	selected.value.push(...list.value)
}

const select = () => {
	emit("select", selected.value)
	selected.value = []
}

const isSelected = file => !!selected.value.find(({ id }) => file.id == id)
const handleSelect = file => {
	if (!file.id) return

	if (isSelected(file)) {
		let i = selected.value.map(({ id }) => id).indexOf(file.id)
		selected.value.splice(i, 1)
	} else {
		selected.value.push(file)

		if (props.onlyOne)
			select()
	}
}

const handleInput = ({ target: { files } }) => {
	onUpload.value = Object.keys(files).map(i => files[i])
}

const remove = async () => {
	pending.value = true

	await ims.remove(selected.value)
	selected.value = []
	await ims.getImages()

	pending.value = false
}

const upload = async () => {
	pending.value = true

	const formData = new FormData()

	for (let file of onUpload.value) {
		formData.append("files", file)
	}
	
	await ims.uploadImages(formData)
	await ims.getImages()

	toast.success(t("default.files_uploaded"))

	onUpload.value = []
	pending.value = false
}

const fetch = async () => await ims.getImages()

onMounted(fetch)
</script>

<style lang="scss" scoped>
.card:deep(.card-content) {
	height: calc(100vh - 25rem);
	overflow-x: hidden;
	overflow-y: auto;

	scrollbar-color: $grey transparent;
	scrollbar-width: thin;

	&::-webkit-scrollbar {
		width: 4px;
	}

	&::-webkit-scrollbar-track {
		background: transparent;
	}

	&::-webkit-scrollbar-thumb {
		background: $grey;
		cursor: pointer;
	}

	&::-webkit-scrollbar-thumb:hover {
		background: $grey;
	}
}
</style>